#include <bits/stdc++.h>
using namespace std;

vector<pair<int,int>> neighbors[81];
long long path[81],punktove[81],k[81];
void dijkstra(int n){
    priority_queue<pair<long long,int>> pq;
    pq.push({0,0});
    for(int i=0;i<n;i++) path[i]=100000000;
    path[0]=0;
    while(!pq.empty()){
        //if(pq.empty()) break;
        int curr=pq.top().second;
        long long q=-pq.top().first;
        pq.pop();
        if(q!=path[curr]) continue;
        for(int i=0;i<neighbors[curr].size();i++){
            int nh=neighbors[curr][i].first;
            int p=neighbors[curr][i].second;
            if(path[nh]>(p+q)){
                path[nh]=p+q;
                punktove[nh]=punktove[curr]+1;
                pq.push({-path[nh],nh});
            }
        }
    }
}
int minp,pu;
bool memoizaciq[1000];
void dfs(int curr, int n){
    if(curr==n-1 || memoizaciq[curr]) return;
    memoizaciq[curr]=true;
    //if(neighbors[curr].size()==0) return false;
    for(int i=0;i<neighbors[curr].size();i++){
        dfs(neighbors[curr][i].first,n);
        int g=neighbors[curr][i].second;
        neighbors[curr][i].second=0;
        dijkstra(n);
        if(path[n-1]<minp){
            minp=path[n-1];
            pu=punktove[n-1];
        }
        neighbors[curr][i].second=g;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin>> n >> m;
    for(int i=0;i<n;i++){
        cin>> k[i];
    }
    for(int i=0;i<m;i++){
        int p,q,t;
        cin>> p >> q >> t;
        p--;q--;
        neighbors[p].push_back({q,t});
    }
    dijkstra(n);
    minp=path[n-1];
    pu=punktove[n-1];
    //cout<< path[n-1] << endl;
    for(int i=0;i<n;i++){
        if(k[i]){
            dfs(i,n);
            //cout<< path[n-1] << endl;
        }
    }
    cout<< minp << " " << pu << endl;
    for(int i=0;i<punktove[n-1];i++){
        cout<< 1 << " " << 1 << endl;
    }



    return 0;
}
/*
5 7
0 1 0 0 0
1 2 1
1 4 10
1 5 100
2 3 2
4 2 1
3 4 3
4 5 4

9 10
1 2 1
1 7 1
8 1 3
2 9 13
7 6 1
6 9 10
6 5 1
4 5 1
4 3 1
3 9 1

*/
