/// OMG, snqg. => "Chestit purvi snqg!";
#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>
#include <cmath>
using namespace std;
typedef unsigned long long ull;

unordered_map<ull, ull> lpdX;
unordered_map<ull, ull> a2;

vector<ull> lpd;
void calcLpd(ull xmax){
    lpd.resize(sqrt(xmax)+100); /// +100 za da dealna s floata, za vseki sluchaj
    for(ull i = 2; i*i < xmax; i++){
        if(lpd[i] == 0){
//            cout << i << " is prime!\n";

            {
                unordered_map<ull, ull>::iterator prevIt;
                bool erasePrevIt = false;
                for(unordered_map<ull, ull>::iterator it = a2.begin(); it != a2.end(); ++it){
                    if(erasePrevIt){
                        erasePrevIt = false;
                        a2.erase(prevIt);
                    }
                    if(it->first % i == 0 && it->second != 0){
                        lpdX.insert({it->first, i});
                        (it->second)--;
                        if(it->second == 0){
                            erasePrevIt = true;
                            prevIt = it;
                        }
                    }
                }
                if(erasePrevIt){
                    erasePrevIt = false;
                    a2.erase(prevIt);
                }
            }
            if(a2.size() == 0){
                return;
            }

            for(ull j = i; j*j < xmax; j += i){
                if(lpd[j] == 0){
                    lpd[j] = i;
                }
            }
        }
    }
    for(unordered_map<ull, ull>::iterator it = a2.begin(); it != a2.end(); ++it){
        if(lpdX.count(it->first) == 0){
            lpdX[it->first] = it->first;
        }
    }
}

int main(){
    ull tmp;
    ull xmax;
    vector<ull> a;
    while(cin >> tmp){
        if(a2.count(tmp)){ a2[tmp]++; }
        else{ a2[tmp] = 1; }
        a.push_back(tmp);
        if(tmp > xmax){ xmax = tmp; }
    }
    calcLpd(xmax);

    for(int i = 0; i < a.size(); i++){
        cout << lpdX[a[i]] << '\n';
    }
    return 0;
}
