#include <iostream>
#include <vector>
#include <deque>
using namespace std;

/// nqma znachenie kude sa, trqbva prosto da sa edno do drugo

int n;
vector<int> a;
int solve(int x, int y){
    vector<bool> b(n);
    for(int i = 0; i < n; i++){ b[i] = (a[i]==x || a[i]==y); }

//    cout << "DOING " << x << ' ' << y << '\n';

    deque<int> nos;
    int firstY = -1, lastY;
    for(int i = 0; i < n; i++){
        if(b[i]){
            if(firstY == -1){ firstY = i; }
            lastY = i;
        }else{
            if(firstY != -1){
                nos.push_back(i);
            }
        }
    }
    while(nos.back() > lastY){ nos.pop_back(); }
//    cout << '\t'; for(deque<int>::iterator it = nos.begin(); it != nos.end(); ++it){ cout << *it << ' '; } cout << '\n';

    vector<int> pfx(n);
    vector<int> sfx(n);
    pfx[0] = b[0];
    sfx[n-1] = b[n-1];
    for(int i = 1; i < n; i++){
        pfx[i] = pfx[i-1] + b[i];
        sfx[n-i-1] = sfx[n-(i-1)-1] + b[n-i-1];
    }
    int sum = 0;
    for(deque<int>::iterator it = nos.begin(); it != nos.end(); ++it){
        if(pfx[*it] <= sfx[*it]){
            sum += pfx[*it];
        }else{
            sum += sfx[*it];
        }
    }

//    int sum = 0;
//    while(nos.size() > 0){
//        cout << "\t\t"; for(int i = 0; i < n; i++){ cout << b[i] << ' '; } cout << '\n';
//        cout << "\t\tnCnt: " << nos.size() << "; sum: " << sum << '\n';
//        int firstN = nos.front(), lastN = nos.back();
//        int frwd = abs(firstN - firstY);
//        int bkwd = abs(lastY - lastN);
//        if(frwd <= bkwd){
//            sum += frwd;
//            b[firstY] = false;
//            b[firstN] = true;
//            firstY ++;
//            nos.pop_front();
//            cout << "\t\t\t" << firstN << ": < " << frwd << '\n';
//        }else{
//            sum += bkwd;
//            b[lastY] = false;
//            b[lastN] = true;
//            lastY --;
//            nos.pop_back();
//            cout << "\t\t\t" << lastN << ": > " << bkwd << '\n';
//        }
//    }

    return sum;
}

int main(){
    int q;
    cin >> n >> q;
    a.resize(n);
    for(int i = 0; i < n; i++){ cin >> a[i]; }

    vector<pair<int, int>> Q;
    Q.resize(q);
    for(int i = 0; i < q; i++){
        cin >> Q[i].first >> Q[i].second;

    }
    vector<int> sol;
    for(int i = 0; i < q; i++){
        sol.push_back(solve(Q[i].first, Q[i].second));
    }
    for(int i = 0; i < q; i++){
//        cout << Q[i].first << ' ' << Q[i].second << ":\n\t";
        cout << sol[i] << '\n';
    }

    return 0;
}
