#include<bits/stdc++.h>

using namespace std;

struct edge1
{
    int v; int t;
    void setval(int _v, int _t)
    {
        v=_v;
        t=_t;
    }
};

struct edge2
{
    int u; int v; int t;
};

const int maxn=81;
int n, m;
vector<edge1>v[maxn];
const int maxt=100001;
short edge_lookup[maxn][maxn][20001];
bool s[maxn];
void read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>s[i];
    }
    int x, y, t;
    edge1 e1;
    for(int i=0;i<m;i++)
    {
        cin>>x>>y>>t;
        e1.setval(y, t);
        v[x].push_back(e1);
        edge_lookup[x][y][t+maxt]=i+1;
    }
}
int used[maxn][maxn];
void init()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=n;j++)
        {
            used[i][j]=INT_MAX;
        }
    }
}
vector<pair<int, int>>route;
vector<pair<int, int>>minroute;
int minT=INT_MAX, minL;
void dfs(int beg,  int len, int cnt_vign, int T)
{
    cnt_vign+=s[beg];
    if(cnt_vign>n)return;
    if(len>2*m)return;
    if(beg==n)
    {
        if(T<minT)
        {
            minT=T;
            minL=len;
            minroute=route;
        }
    }
//    p[beg]=par;
    used[beg][cnt_vign]=T;
    int sz=v[beg].size();
    for(int i=0;i<sz;i++)
    {
        edge1 nb=v[beg][i];
        if(T+nb.t<used[nb.v][cnt_vign])
        {
            route.push_back({edge_lookup[beg][nb.v][maxt+nb.t], 1});
            dfs(nb.v,  len+1, cnt_vign, T+nb.t);
            route.pop_back();
        }
        if(T<used[nb.v][cnt_vign-1]&&cnt_vign>0)
        {
            route.push_back({edge_lookup[beg][nb.v][maxt+nb.t], 0});
            dfs(nb.v,  len+1, cnt_vign-1, T);
            route.pop_back();
        }
    }
}

void solve()
{
    read();
    init();
    dfs(1, 0, 0, 0);
    cout<<minT<<" "<<minL<<endl;
    for(int i=0;i<minL;i++)
    {
        cout<<minroute[i].first<<" "<<minroute[i].second<<endl;
    }

}

int main()
{
    solve();
	return 0;
}
