#include<bits/stdc++.h>

using namespace std;
struct country {
    bool vin;
    vector<pair<pair<country*, int>, int>> to;
    int time;
    int id;
    int road_length;
    int path[1000];
};
country countries[80];
int main() {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++) {
        cin >> countries[i].vin;
        countries[i].time = ~(1 << 31);
        countries[i].id = i;
        countries[i].road_length = 0;
    }
    for(int i = 0; i < m; i++) {
        int x, y, t;
        cin >> x >> y >> t;
        countries[x-1].to.push_back(make_pair(make_pair(&countries[y-1], i+1), t));

    }
    int country = 0;
    countries[0].time = 0;
    std::priority_queue<int, std::vector<int>, std::greater<int> > next_countries;
    set<int> visited_countries;
    next_countries.push(0);
    visited_countries.insert(0);

    while(!next_countries.empty()) {
        country = next_countries.top();
        next_countries.pop();
        for(auto x : countries[country].to) {
            //cout << country << " -> " << x.first.first->id << "; t = " << x.second << "; t(self) = " << countries[country].time << "; t(next, tmp) = " << x.second + countries[country].time << endl;
            if(visited_countries.find(x.first.first->id) == visited_countries.end()){
                next_countries.push(x.first.first->id);
                visited_countries.insert(x.first.first->id);
            }
            if(x.first.first->time > countries[country].time + x.second) {
                x.first.first->time = countries[country].time + x.second;
                for(int i = 0; i < countries[country].road_length; i++) {
                    x.first.first->path[i] = countries[country].path[i];
                }
                x.first.first->path[countries[country].road_length] = x.first.second;
                x.first.first->road_length = countries[country].road_length + 1;
            }
        }

    }
    cout << countries[n-1].time << " " << countries[n-1].road_length << endl;
    for(int i = 0; i < countries[n-1].road_length; i++) {
        cout << countries[n-1].path[i] << " 1" << endl;
    }
}
