#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 82, maxm = 1000;
long long m, s[maxn], dp[maxn][maxn], len[maxn][maxn];
int n, bt[maxn][maxn], used[maxn][maxn], befx[maxn][maxn], befv[maxn][maxn];

struct edge{
    int x, y, t;
};

vector<edge> v;

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++)
        cin >> s[i];
    for(int i = 1;i <= m;i++){
        int x, y, t;
        cin >> x >> y >> t;
        v.push_back({x, y, t});
    }
}
int cnt = 0;

void backtrack(int ver, int vin){
    if(ver == 1)
        return;
    backtrack(befx[ver][vin], befv[ver][vin]);
    cout << bt[ver][vin] << " " << 1 - used[ver][vin] << endl;
}
void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= n;j++){
            dp[i][j] = 1e17;
        }
    }
    dp[1][0] = 0;
    if(s[1] == 1){
        dp[1][1] = 0;
    }
    for(int cycle = 1;cycle <= 2*m;cycle++){
        bool f = true;
        for(int i = 0;i < v.size();i++){
            edge e = v[i];
            for(int v = 0;v <= n;v++){
                if(dp[e.x][v] == 1e17)
                    continue;
                int j = v + s[e.y];
                if(j > n)
                    j = n;
                if(dp[e.y][j] > dp[e.x][v] + e.t){
                    dp[e.y][j] = min(dp[e.y][j], dp[e.x][v] + e.t);
                    len[e.y][j] = len[e.x][v] + 1;
                    bt[e.y][j] = i + 1;
                    used[e.y][j] = 0;
                    befv[e.y][j] = v;
                    befx[e.y][j] = e.x;
                    f = false;
                }
                if(v > 0){
                    if(dp[e.y][j - 1] > dp[e.x][v]){
                        dp[e.y][j - 1] = dp[e.x][v];
                        len[e.y][j - 1] = len[e.x][v] + 1;
                        bt[e.y][j - 1] = i + 1;
                        used[e.y][j - 1] = 1;
                        befv[e.y][j - 1] = v;
                        befx[e.y][j - 1] = e.x;
                        f = false;
                    }

                }
            }
        }
        if(f)
            break;
    }
    long long idx = 1;
    for(int i = 0;i <= n;i++){
        if(dp[n][idx] > dp[n][i])
            idx = i;
    }
    cout << dp[n][idx] << " " << len[n][idx] << endl;
    backtrack(n, idx);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
