#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 82, maxm = 1002;
long long m, s[maxn], dp[maxn][maxm][maxn];
int n, bt[maxn][maxm][maxn], befx[maxn][maxm][maxn], befv[maxn][maxm][maxn], befl[maxn][maxm][maxn];
int used[maxn][maxm][maxn];
vector< pair<int, int> > vr[maxn];

struct edge{
    int x, y, t;
};

vector<edge> v;

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++)
        cin >> s[i];
    for(int i = 1;i <= m;i++){
        int x, y, t;
        cin >> x >> y >> t;
        v.push_back({x, y, t});
    }
}

void backtrack(int ver, int l, int vin){
    if(l == 0)
        return;
    backtrack(befx[ver][l][vin], befl[ver][l][vin], befv[ver][l][vin]);
    cout << bt[ver][l][vin] << " " << 1 - used[ver][l][vin] << endl;
}
void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= 2 * m;j++){
            for(int k = 0;k <= n;k++)
                dp[i][j][k] = 1e17;
        }
    }
    dp[1][0][0] = 0;
    vr[1].push_back({0, 0});
    if(s[1] == 1){
        dp[1][0][1] = 0;
        vr[1].push_back({0, 1});
    }
    for(int cycle = 1;;cycle++){
        bool f = true;
        for(int i = 0;i < v.size();i++){
            edge e = v[i];
            for(pair<int, int> curr : vr[e.x]){
                    int p = curr.first + 1, v = curr.second;
                    int j = v + s[e.y];
                    if(dp[e.y][p][j] > dp[e.x][p - 1][v] + e.t){
                        bool flag = true;
                        if(dp[e.y][p][j] == 1e17)
                            flag = false;
                        dp[e.y][p][j] = dp[e.x][p - 1][v] + e.t;
                        befx[e.y][p][j] = e.x;
                        befv[e.y][p][j] = v;
                        befl[e.y][p][j] = p - 1;
                        bt[e.y][p][j] = i + 1;
                        used[e.y][p][j] = 0;
                        if(!flag){
                            vr[e.y].push_back({p, j});
                        }
                        f = false;
                    }
                    if(v > 0){
                        if(dp[e.y][p][j - 1] > dp[e.x][p - 1][v]){
                            bool flag = true;
                            if(dp[e.y][p][j - 1] == 1e17)
                                flag = false;
                            dp[e.y][p][j - 1] = dp[e.x][p - 1][v];
                            befx[e.y][p][j - 1] = e.x;
                            befv[e.y][p][j - 1] = v;
                            befl[e.y][p][j - 1] = p - 1;
                            bt[e.y][p][j - 1] = i + 1;
                            used[e.y][p][j - 1] = 1;
                            if(flag == false){
                                vr[e.y].push_back({p, j - 1});
                            }
                            f = false;
                        }
                    }
                }

            }
        if(f)
            break;
    }
    long long idx = 0, vin = 0;
    for(int i = 0;i <= 2 * m;i++){
        for(int j = 0;j <= n;j++){
            if(dp[n][idx][vin] > dp[n][i][j])
                idx = i, vin = j;
        }
    }
    cout << dp[n][idx][vin] << " " << idx << endl;
    backtrack(n, idx, vin);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
