#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 82, maxm = 1002;
long long m, s[maxn], dp[maxn][maxm][maxn];
int n, bt[maxn][maxm][maxn], befx[maxn][maxm][maxn], befv[maxn][maxm][maxn], befl[maxn][maxm][maxn];
int used[maxn][maxm][maxn];

struct edge{
    int x, y, t;

    bool operator<(const edge &e) const{
        return dp[x][y][e.t] > dp[x][y][t];
    }
};

vector<edge> v[maxn];

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++)
        cin >> s[i];
    for(int i = 1;i <= m;i++){
        int x, y, t;
        cin >> x >> y >> t;
        v[x].push_back({y, t, i});
    }
}

void backtrack(int ver, int l, int vin){
    if(l == 0)
        return;
    backtrack(befx[ver][l][vin], befl[ver][l][vin], befv[ver][l][vin]);
    cout << bt[ver][l][vin] << " " << 1 - used[ver][l][vin] << endl;
}
void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= 2 * m;j++){
            for(int k = 0;k <= n;k++)
                dp[i][j][k] = 1e17;
        }
    }
    dp[1][0][0] = 0;
    priority_queue<edge> q;
    q.push({1, 0, 0});
    if(s[1] == 1){
        dp[1][0][1] = 0;
        q.push({1, 0, 1});
    }
    while(!q.empty()){
        edge t = q.top();
        q.pop();
        for(edge nb : v[t.x]){
            int j = t.t + s[nb.x];
            if(j > n)
                j = n;
            if(dp[nb.x][t.y + 1][j] > dp[t.x][t.y][t.t] + nb.y){
                dp[nb.x][t.y + 1][j] = dp[t.x][t.y][t.t] + nb.y;
                befx[nb.x][t.y + 1][j] = t.x;
                befl[nb.x][t.y + 1][j] = t.y;
                befv[nb.x][t.y + 1][j] = t.t;
                bt[nb.x][t.y + 1][j] = nb.t;
                used[nb.x][t.y + 1][j] = 0;
                if(t.y + 1 != 2 * m)
                    q.push({nb.x, t.y + 1, j});
            }
            if(t.t > 0){
                if(dp[nb.x][t.y + 1][j - 1] > dp[t.x][t.y][t.t]){
                    dp[nb.x][t.y + 1][j - 1] = dp[t.x][t.y][t.t];
                    befx[nb.x][t.y + 1][j - 1] = t.x;
                    befl[nb.x][t.y + 1][j - 1] = t.y;
                    befv[nb.x][t.y + 1][j - 1] = t.t;
                    bt[nb.x][t.y + 1][j - 1] = nb.t;
                    used[nb.x][t.y + 1][j - 1] = 1;
                    if(t.y + 1 != 2 * m)
                        q.push({nb.x, t.y + 1, j - 1});
                }
            }
        }
    }
    int idx = 0, vin = 0;
    for(int i = 1;i <= 2 * m;i++){
        for(int j = 0;j <= n;j++){
            if(dp[n][idx][vin] > dp[n][i][j])
                idx = i, vin = j;
        }
    }
    cout << dp[n][idx][vin] << " " << idx << endl;
    backtrack(n, idx, vin);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
