#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const long long maxn = 1e6 + 10;
long long n, q, a[maxn], cnt[maxn], l[maxn];
vector<long long> v[maxn], pref[maxn];

void read(){
    cin >> n >> q;
    for(long long i = 1;i <= n;i++){
        cin >> a[i];
        cnt[a[i]]++;
        v[a[i]].push_back(i);
        if(v[a[i]].size() == 1){
            pref[a[i]].push_back(i);
        }
        else{
            pref[a[i]].push_back(pref[a[i]].back() + i);
        }
    }
}

long long x, y, S = 0;
void calc(long long pos, long long t){
    long long l = 0, r = v[x].size() - 1, ans = -1;
    while(l <= r){
        long long mid = (l + r) / 2;
        if(v[x][mid] <= pos)
            l = mid + 1, ans = mid;
        else
            r = mid - 1;
    }
    S = 0;
    long long lf = 0;
    long long szx = v[x].size();
    if(ans != -1){
        S = -pref[x][ans];
        lf += ans + 1;
    }
    if(ans != szx - 1){
        S += pref[x][szx - 1];
        if(ans != -1)
            S -= pref[x][ans];
    }
    l = 0, r = v[y].size() - 1, ans = -1;
    while(l <= r){
        long long mid = (l + r) / 2;
        if(v[y][mid] <= pos)
            l = mid + 1, ans = mid;
        else
            r = mid - 1;
    }
    if(ans != -1){
        S -= pref[y][ans];
        lf += ans + 1;
    }
    long long szy = v[y].size();
    if(ans != szy - 1){
        S += pref[y][szy - 1];
        if(ans != -1)
            S -= pref[y][ans];
    }
    long long rg = szx + szy - lf;
    if(lf != 0){
        long long oth = pos - lf + 1;
        S += (pos + 1) * pos / 2 - oth * (oth - 1) / 2;
    }
    if(rg != 0){
        long long oth = pos + rg;
        S = S - (oth * (oth + 1) / 2 - (pos) * (pos + 1) / 2);
    }
}

bool check(int pos, int t){
    int cnt = 0;
    int l = 0, r = v[x].size() - 1, ans = -1;
    while(l <= r){
        int mid = (l + r) >> 1;
        if(v[x][mid] <= pos)
            l = mid + 1, ans = mid;
        else
            r = mid - 1;
    }
    cnt += (ans + 1);
    if(cnt >= t)
        return true;
    int ost = t - cnt;
    if(v[y].size() < ost)
        return false;
    return v[y][ost - 1] <= pos;
}

void solve(){
    while(q--){
        cin >> x >> y;
        long long l = 1, r = min(v[x][cnt[x] / 2 + cnt[x] % 2], v[y][cnt[y] / 2 + cnt[y] % 2]);
        long long t = (cnt[x] + cnt[y]) / 2 + (cnt[x] + cnt[y]) % 2;
        l = t;
        while(l <= r){
            long long mid = (l + r) / 2;
            if(check(mid, t))
                r = mid - 1;
            else
                l = mid + 1;
        }
        calc(l, t);
        cout << S << endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
