#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 1000000;
ll lpd[maxN];

int main()
{
    for (int i = 0; i < maxN; i++)
    {
        lpd[i] = -1;
    }
    for (int step = 2; step < maxN; step++)
    {
        if (lpd[step] != -1)
        {
            continue;
        }
        for (int i = step; i < maxN; i += step)
        {
            if (lpd[i] == -1)
            {
                lpd[i] = step;
            }
        }
    }

    ll temp;
    while (cin >> temp)
    {
        cout << lpd[temp] << endl;
    }
}
