#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 1000100;
bool isPrime[maxN];
ll primes[maxN];
ll primesLen = 0;

//ll lpd(ll a)
//{
//    for (ll i = 2; i * i <= a; i++)
//    {
//        if (!isPrime[i]) continue;
//        if (a % i == 0) return i;
//    }
//
//    return a;
//}

ll lpd(ll a)
{
    for (int i = 0; primes[i] * primes[i] <= a; i++)
    {
        if (a % primes[i] == 0) return primes[i];
    }

    return a;
}

int main()
{
    for (int i = 0; i < maxN; i++)
    {
        isPrime[i] = true;
    }
    for (int step = 2; step < maxN; step++)
    {
        if (!isPrime[step]) continue;
        for (int i = step * 2; i < maxN; i += step)
        {
            isPrime[i] = false;
        }
    }

    for (int i = 2; i < maxN; i++)
    {
        if (isPrime[i])
        {
            primes[primesLen] = i;
            primesLen++;
        }
    }

    ll temp;
    while (cin >> temp)
    {
        cout << lpd(temp) << endl;
    }
}