#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e6;

vector <int> primes;
bool isPrime[MAXN+100];

void Euclid(int n)
{
    for (int i = 2; i <= n; i++)
        isPrime[i] = true;

    for (int i = 2; i <= n; i++)
    {
        if (isPrime[i] == true)
            primes.push_back(i);

        for (int d = 2; i*d <= n; d++)
        {
            isPrime[i*d] = false;
            if (i%d == 0)
                break;
        }
    }
}

vector <int> arr;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int maxA = 0, a;
    while (cin >> a)
    {
        arr.push_back(a);
        maxA = max(maxA, a);
    }

    int t = arr.size();
    int sqrtA = sqrt(maxA) + 1;

    Euclid(sqrtA);

    for (int i:arr)
    {
        bool flag = false;
        for (int p:primes)
        {
            if (i%p == 0)
            {
                cout << p << endl;
                flag = true;
                break;
            }
        }

        if (flag == false)
            cout << i << endl;
    }

    return 0;
}
