#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 88;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m,s[MAXN];
int dist[MAXN][MAXN], path[MAXN][MAXN];
int inf = 1e9;
void precompute()
{
    for (int i = 1; i <= n; ++ i)
    {
        for(int j = i + 1; j <= n; ++ j)
        {
            dist[i][j] = inf;
            dist[j][i] = inf;
            path[i][j] = 0;
            path[j][i] = 0;
        }
    }
}
int xx, yy, cost;
int main()
{
    speed();
    cin >> n >> m;
    precompute();
    for (int i = 1; i <= n; ++ i)
        cin >> s[i];
    for (int i = 1; i <= m; ++ i)
    {
        cin >> xx >> yy >> cost;
        path[xx][yy] = 2;
        dist[xx][yy] = min(dist[xx][yy], cost);
    }
    for (int cycle = 1; cycle <=2* n; ++ cycle)
   {

    for (int k = 1; k <= n; ++ k)
    {
        for (int i = 1; i <= n; ++ i)
        {
            for (int j = 1; j <= n; ++ j)
            {
                if(i == j || i == k || j == k)continue;
                if(dist[i][k]!=inf && dist[k][j]!=inf && dist[i][j] > dist[i][k] + dist[k][j])
                {
                    int newpath= path[i][k] + path[k][j] - 1;
                    if(newpath < 2*m)
                    {dist[i][j] = dist[i][k] + dist[k][j];
                    path[i][j] = path[i][k] + path[k][j];
                    }
                }
            }
        }
    }
   }



    cout << dist[1][n] << " " << path[1][n] << endl;
    return 0;
}
