#include<iostream>
#include<bits/stdc++.h>
#define MAXN 100
#define INF 9999999
using namespace std;
bool s[MAXN];
bool used[MAXN];
long long dist[MAXN];
int ln[MAXN];
vector<pair<int,long long>> edges[MAXN];
void bfs(int st, int n)
{
    queue<pair<pair<int,long long>,int>> q;
    q.push({{st,0},0});
    used[st]=0;
    while(!q.empty())
    {
        int curr=q.front().first.first;
        long long val=q.front().first.second;
        int l=q.front().second;
        q.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int curr2=edges[curr][i].first;
            long long val2=edges[curr][i].second;
            if(s[curr] && val2>0)val2=0;
            if(used[curr2]==0 || dist[curr2]>val+val2)
            {
                used[curr2]=1;
                if(dist[curr2]>val+val2)
                {
                    dist[curr2]=val+val2;
                    ln[curr2]=l+1;
                }
                q.push({{curr2,val+val2},l+1});
            }
        }
    }
}
int main()
{
    int n,m;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>s[i];
        dist[i]=INF;
    }
    for(int i=0;i<m;i++)
    {
        int u,v,x;
        cin>>u>>v>>x;
        edges[u].push_back({v,x});
    }
    bfs(1,n);
    cout<<dist[n]<<" "<<ln[n]<<"\n";
}