#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 81
#define MAXM 501
using namespace std;

vector<pair<int,pair<int,int>>> edges[MAXN];
int previous[MAXN];
int dist[MAXN];
int brP[MAXN];
int m;
int n;
/*priority_queue<pair<int,int>> pq;
void dijkstra()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    previous[1] = -1;
    brP[1] = 1;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int curr = pq.top().second;
        int currDist = -pq.top().first;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        for (auto next : edges[curr])
        {
            int v = next.first;
            int w = next.second;
            if ( currDist + w < dist[v] && brP[curr] + 1 <= 2*m )
            {
                dist[v] = currDist + w;
                previous[v] = curr;
                brP[v] = brP[curr] + 1;
                pq.push({-dist[v], v});
            }
        }
    }
}*/
void bellmanford()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    brP[1] = 0;
    
    for (int k=1; k<=2*m; k++)//!!
    {
        for (int i=1; i<=n; i++)
            for (auto edge : edges[i])
        {
            int w = edge.second.first;
            int v = edge.first;
         
            if ( dist[i] != INT_MAX && dist[i] + w < dist[v]  )
            {
                dist[v] = dist[i] + w;
                brP[v] = brP[i] + 1;
            }
        }
    }
}
stack<int> path;
int edgeInput[MAXM];
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    int s;
    for (int i=1; i<=n; i++)
        cin >> s;
    bool neg = true;
    for (int j=0; j<m; j++)
    {
        int a, b, t;
        if ( t < 0 ) neg = true;
        cin >> a >> b >> t;
        edges[a].push_back({b, {t, j}});
        edgeInput[j] = a;
    }
    int T, L;
    if ( !neg )
    {
       // dijkstra();

        T = dist[n];
        L = brP[n];
    }
    else
    {
        bellmanford();
        T = dist[n];
        L = brP[n];
    }

    cout << T << " " << L << endl;
/*
    while ( true )
    {
        if ( previous[n] == -1) break;

        path.push(n+1);

        n = edgeInput[ previous[ edgeInput[n] ] ];
    }

    while ( !path.empty() )
    {
        cout << path.top() << " " << 0 << endl;;
        path.pop();
    }
*/
}
/*
3 3
0 0 0
1 2 -3
2 3 -7
3 2 -11
----------------
-42
==============
5 5
0 0 0 0 0
1 2 -2
2 3 4
2 4 8
4 3 -10
3 5 -5
---------------
-9 5
1 0
2 0
4 0
3 0
5 0
========================
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 5
1 0
2 0
4 0
5 0
6 0
*/
