#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 81
#define MAXM 501
using namespace std;

vector<pair<long long,pair<long long,long long>>> edges[MAXN];
long long previous[MAXN];
long long dist[MAXN];
long long brP[MAXN];
long long m;
long long n;
/*priority_queue<pair<long long,long long>> pq;
void dijkstra()
{
    fill_n(dist, n+1, long long_MAX);
    dist[1] = 0;
    previous[1] = -1;
    brP[1] = 1;
    pq.push({0, 1});
    while (!pq.empty())
    {
        long long curr = pq.top().second;
        long long currDist = -pq.top().first;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        for (auto next : edges[curr])
        {
            long long v = next.first;
            long long w = next.second;
            if ( currDist + w < dist[v] && brP[curr] + 1 <= 2*m )
            {
                dist[v] = currDist + w;
                previous[v] = curr;
                brP[v] = brP[curr] + 1;
                pq.push({-dist[v], v});
            }
        }
    }
}*/
void bellmanford()
{
    fill_n(dist, n+1, long long_MAX);
    dist[1] = 0;
    brP[1] = 0;
    long long old = long long_MAX;
    for (;;)//!!
    {
        for (long long i=1; i<=n; i++)
            for (auto edge : edges[i])
        {
            long long w = edge.second.first;
            long long v = edge.first;

            if ( dist[i] != long long_MAX && dist[i] + w < dist[v] && brP[i] + 1 <= 2*m )
            {
                dist[v] = dist[i] + w;
                brP[v] = brP[i] + 1;
            }
        }
        if ( old != long long_MAX && dist[n] == old ) break;
        old = dist[n];
    }
}
stack<long long> path;
long long edgeInput[MAXM];
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    long long s;
    for (long long i=1; i<=n; i++)
        cin >> s;
    bool neg = true;
    for (long long j=0; j<m; j++)
    {
        long long a, b, t;
        if ( t < 0 ) neg = true;
        cin >> a >> b >> t;
        edges[a].push_back({b, {t, j}});
        edgeInput[j] = a;
    }
    long long T, L;
    if ( !neg )
    {
       // dijkstra();

        T = dist[n];
        L = brP[n];
    }
    else
    {
        bellmanford();
        T = dist[n];
        L = brP[n];
    }

    cout << T << " " << L << endl;

}
/*
3 3
0 0 0
1 2 -3
2 3 -7
3 2 11
----------------
-10 2
==================
3 3
0 0 0
1 2 -3
2 3 -7
3 2 -11
----------------
-42
==============
5 5
0 0 0 0 0
1 2 -2
2 3 4
2 4 8
4 3 -10
3 5 -5
---------------
-9 5
1 0
2 0
4 0
3 0
5 0
========================
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 4
1 0
2 0
4 0
5 0
6 0
*/
