#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 81
#define MAXM 501
using namespace std;

vector<pair<int,int>> edges[MAXN];

int dist[MAXN];
int brP[MAXN];
int m;
int n;

void bellmanford()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    brP[1] = 0;
    int old = INT_MAX;
    for (;;)
    {
        for (int i=1; i<=n; i++)
            for (auto edge : edges[i])
            {
                int w = edge.second;
                int v = edge.first;

                if ( dist[i] != INT_MAX && dist[i] + w < dist[v] && brP[i] + 1 <= 2*m )
                {
                    dist[v] = dist[i] + w;
                    brP[v] = brP[i] + 1;
                }
            }
        if ( old != INT_MAX && (dist[n] == old || brP[n] == 2*m) ) break;
        old = dist[n];
    }
}
stack<int> path;
int edgeInput[MAXM];
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    int s;
    for (int i=1; i<=n; i++)
        cin >> s;

    for (int j=0; j<m; j++)
    {
        int a, b, t;

        cin >> a >> b >> t;
        edges[a].push_back({b, {t, j}});
        edgeInput[j] = a;
    }
    int T, L;

    bellmanford();
    T = dist[n];
    L = brP[n];


    cout << T << " " << L << endl;

}
/*
3 3
0 0 0
1 2 -3
2 3 -7
3 2 -11
----------------
-42
==============
5 5
0 0 0 0 0
1 2 -2
2 3 4
2 4 8
4 3 -10
3 5 -5
---------------
-9 5
1 0
2 0
4 0
3 0
5 0
========================
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 5
1 0
2 0
4 0
5 0
6 0
*/
