#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist,num,vin;
    edge(){};
    edge(int ve, int di, int ni, int vi)
    {
        ver = ve;
        dist = di;
        num = ni;
        vin = vi;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 85;

int n,m,s[maxn];
vector<edge>g[maxn];
unsigned int d[maxn][maxn],inf = -1;
int par[maxn],nom[maxn],vin[maxn];
vector<pair<int,int> >ans;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++) cin >> s[i];
    int a,b,t;
    for(int i=1;i<=m;i++)
    {
        cin >> a >> b >> t;
        g[a].push_back({b,t,i,s[a]});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    d[beg][s[1]] = 0;
    priority_queue<edge>q;
    q.push({beg,0,0,s[1]});
    while(!q.empty())
    {
        edge e = q.top();
        q.pop();
        if(e.dist<=d[e.ver][e.vin])
        {
            for(edge nb:g[e.ver])
            {
                edge pom = nb;
                nb.vin += e.vin;
                if(nb.dist+e.dist<d[nb.ver][nb.vin])
                {
                    nb.dist += e.dist;
                    d[nb.ver][nb.vin] = nb.dist;
                    par[nb.ver] = e.ver;
                    nom[nb.ver] = nb.num;
                    vin[nb.ver] = 0;
                    q.push(nb);
                }
                nb = pom;
                nb.vin += e.vin;
                nb.vin --;
                if(nb.vin>=0&&0+e.dist<d[nb.ver][nb.vin])
                {
                    nb.dist = e.dist;
                    d[nb.ver][nb.vin] = nb.dist;
                    par[nb.ver] = e.ver;
                    nom[nb.ver] = nb.num;
                    vin[nb.ver] = 1;
                    q.push(nb);
                }
            }
        }
    }
}

void rec(int x)
{
    if(nom[x]==0) return;
    rec(par[x]);
    ans.push_back({nom[x],vin[x]});
}

void solve()
{
    dijkstra(1);
    cout << d[n] << " ";
    rec(n);
    cout << ans.size() << endl;
    for(int i=0;i<ans.size();i++) cout << ans[i].first << " " << ans[i].second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
