#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1e6+5;
int n,q;
int a[maxn];
int sz1,sz2;
long long p1,p2;
vector<long long>v[maxn],pref[maxn],suff[maxn];

int find_idx1(int x, int i)
{
    int l = 0, r = v[x].size()-1;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(v[x][mid]<=i) l = mid+1;
        else r = mid-1;
    }
    return r;
}

int find_idx2(int y, int i)
{
    int l = 0, r = v[y].size()-1;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(v[y][mid]<=i) l = mid+1;
        else r = mid-1;
    }
    return r;
}

long long check1(long long i, int x, int y)
{
    long long pom = 0;
    if(p1>=0)
    {
        pom += pref[x][p1];
        pom += (i-v[x][p1])*(p1+1);
    }
    if(p2>=0)
    {
        pom += pref[y][p2];
        pom += (i-v[y][p2])*(p2+1);
    }
    pom -= (p1+1)*(p2+1);
    return pom;
}

long long check2(long long i, int x, int y)
{
    long long pom = 0;
    if(p1+1<sz1)
    {
        pom += suff[x][p1+1];
        pom += (v[x][p1+1]-(i+1))*(sz1-p1-1);
    }
    if(p2+1<sz2)
    {
        pom += suff[y][p2+1];
        pom += (v[y][p2+1]-(i+1))*(sz2-p2-1);
    }
    pom -= (sz1-p1-1)*(sz2-p2-1);
    return pom;
}

void solve(pair<int,int> p)
{
    int x,y;
    x = p.first;
    y = p.second;
    sz1 = v[x].size();
    sz2 = v[y].size();
    long long ans = n;
    ans *= ans;
    long long l = 1, r = n-1;
    long long mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        p1 = find_idx1(x,mid);
        p2 = find_idx2(y,mid);
        if(check1(mid,x,y)<check2(mid,x,y)) l = mid+1;
        else r = mid-1;
    }
    p1 = find_idx1(x,l);
    p2 = find_idx2(y,l);
    if(l<=n-1) ans = min(ans,check1(l,x,y)+check2(l,x,y));
    p1 = find_idx1(x,l-1);
    p2 = find_idx2(y,l-1);
    if(l-1>=1) ans = min(ans,check1(l-1,x,y)+check2(l-1,x,y));
    cout << ans << endl;
}

void pre()
{
    for(int x=1;x<=n;x++)
    {
        int sz = v[x].size();
        if(sz==0) continue;
        pref[x].resize(sz);
        suff[x].resize(sz);
        pref[x][0] = 0;
        for(int i=1;i<sz;i++) pref[x][i] = pref[x][i-1] + i*(v[x][i]-v[x][i-1]-1);
        suff[x][sz-1] = 0;
        for(int i=sz-2;i>=0;i--) suff[x][i] = suff[x][i+1] + (sz-i-1)*(v[x][i+1]-v[x][i]-1);
    }
}

void read()
{
    cin >> n >> q;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i];
        v[a[i]].push_back(i);
    }
    pre();
    pair<int,int>p;
    for(int z=1;z<=q;z++)
    {
        cin >> p.first >> p.second;
        solve(p);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
