#include <iostream>
#include <chrono>
#include <vector>
#include <stack>
#include <assert.h>
#include <map>
#include <cmath>

#define maxn 50000005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

long long n;


vector <long long> prime;
bool sieve[40000005];
vector <long long> numbers;

void _sieve(int n)
{
    for(int i = 2; i <= n; i++)
    {
        if(sieve[i] == 0)
        {

            prime.pb(i);

            sieve[i] = true;
            for(int j = i; j <= n; j += i)
            {
                if(sieve[j] == 0) sieve[j] = true;
            }
        }
    }
}

long long minn = LINF;
long long maxx = -LINF;


long long ans[5000005];

void solve()
{
    double to = 1;
    for(short int i = 1; i <= 15; i++) to *= 10;
    to = ceil(sqrt(to));

    double to2 = 1;
    for(short int i = 1; i <= 12; i++) to2 *= 10;
    to2 = ceil(sqrt(to2));

    ///cout << "-> " << to << endl;


    ///cin >> t;
    while( cin >> n )
    {
        if(n > maxx) maxx = n;
        if(minn > n) minn = n;
        numbers.pb(n);
    }

    if(maxx <= 1000000000000)
    {

        _sieve(to2);

        for(long long e : numbers)
        {

            bool lamp = true;

            for(long long cur : prime)
            {
                if(e % cur == 0)
                {
                    cout << cur << endl;
                    lamp = false;
                    break;
                }
            }
            if(lamp) cout << e << endl;
        }


    }
    else
    {

        _sieve(to);

        ///assert(false);

        for(long long cur : prime)
        {

            long long start = (minn / cur);

            if(minn % cur != 0) start++;
            start *= cur;

            for(long long j = start; j <= maxx; j += cur)
            {
                if(ans[j - minn] == 0) ans[j - minn] = cur;
            }
        }

        for(long long e : numbers)
        {
            ///if(ans[e - minn] == 0) assert(false);
            ///cout << ans[e - minn] << endl;

            if(ans[e - minn] == 0) cout << e << endl;
            else cout << ans[e - minn] << endl;

        }

    }

}


int main()
{

/**#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ///startT = std::chrono::high_resolution_clock::now();

    solve();


    return 0;
}
