#include <iostream>
#include <chrono>
#include <vector>
#include <cmath>

#define maxn 100005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}


int n , q;

int a[maxn];

void read()
{
    cin >> n >> q;

    for(int i = 1; i <= n; i++) cin >> a[i];

}

vector <int> pos;

int check(int x)
{
    int cur_ans = 0;

    for(int i = 0; i < pos.size(); i++)
    {
        cur_ans += abs(pos[i] - x - i + 1 - 1);
    }

    return cur_ans;

}

/**int bin_search()
{
    int l = 1 , r = n;

    int l_cost = check(l) , r_cost = check(r);
    int mid;
    int mid_cost = check((l + r) / 2);

    while(l < r)
    {
        mid = (l + r) / 2;

        if(l_cost < r_cost)

    }


}
*/

int ans_query(int val1 , int val2)
{

    pos.clear();

    for(int i = 1; i <= n; i++) if(a[i] == val1 || a[i] == val2) pos.push_back(i);

    int min_cost = INF;

    int l , r;
    int last = 0;

    if(pos[0] == 1)
    {
        last = 1;
        l = 1;
        r = pos.size() - 1;
    }
    else
    {
        l = 0;
        r = pos.size();
    }

    ///cout << l << " " << r << endl;

    int cur_cost = check(1);

    min_cost = cur_cost;

    ///cout << min_cost << " ";

    for(int start = 2; start <= n; start++)
    {
        if(start + pos.size() - 1 > n) break;

        bool lamp = false;

        if(pos[last] == start)
        {
            lamp = true;
            l++;
            ///r--;
            last++;
        }

        cur_cost += l;
        cur_cost -= r;
        ///cout << "-> " << l << " " << r << endl;
        ///cout << cur_cost << " ";

        min_cost = min(min_cost , cur_cost);

        if(lamp)
        {
            //l++;
            r--;
        }
    }

    ///cout << endl;

    return min_cost;

}

void solve()
{
    int x , y;

    for(int i = 1; i <= q; i++)
    {
        cin >> x >> y;

        cout << ans_query(x , y) << endl;

    }

}

int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    read();
    solve();

    ///cout << sqrt(15) << endl;

    return 0;
}
