#include <bits/stdc++.h>
using namespace std;

vector<pair<int,int>> neighbors[81];
long long path[81],punktove[81];
int dijkstra(int n){
    priority_queue<pair<int,int>> pq;
    pq.push({0,0});
    for(int i=0;i<n;i++) path[i]=10000;
    path[0]=0;
    while(!pq.empty()){
        int curr=pq.top().second;
        int q=-pq.top().first;
        pq.pop();
        if(q!=path[curr]) continue;
        for(int i=0;i<neighbors[curr].size();i++){
            int nh=neighbors[curr][i].first;
            int p=neighbors[curr][i].second;
            if(path[nh]>(p+q)){
                path[nh]=p+q;
                punktove[nh]=punktove[curr]+1;
                pq.push({-path[nh],nh});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin>> n >> m;
    for(int i=0;i<n;i++){
        int k;
        cin>> k;
    }
    for(int i=0;i<m;i++){
        int p,q,t;
        cin>> p >> q >> t;
        p--;q--;
        neighbors[p].push_back({q,t});
    }
    dijkstra(n);
    cout<< path[n-1] << " " << punktove[n-1] << endl;
    for(int i=0;i<punktove[n-1];i++){
        cout<< 1 << " " << 1 << endl;
    }



    return 0;
}
/*
5 7
1 2 1
1 4 10
1 5 100
2 3 2
4 2 1
3 4 3
4 5 4
*/
