/// OMG, snqg. => "Chestit purvi snqg!";
#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>
#include <cmath>
using namespace std;
typedef unsigned long long ull;

unordered_map<ull, ull> lpdX;
set<ull> a;

vector<ull> lpd;
void calcLpd(ull xmax){
    lpd.resize(sqrt(xmax)+100); /// +100 za da dealna s floata, za vseki sluchaj
    for(ull i = 2; i*i < xmax; i++){
        if(lpd[i] == 0){
//            cout << i << " is prime!\n";
            for(ull j = i; j*j < xmax; j += i){
                if(lpd[j] == 0){
//                    cout << "mark " << j << '\n';
                    lpd[j] = i;
                    if(a.count(j) != 0){
                        lpdX.insert({j, i});
                    }
                    if(a.size() == lpdX.size()){
                        return;
                    }
                }
            }
        }
    }
    for(set<ull>::iterator it = a.begin(); it != a.end(); ++it){
        if(lpdX.count(*it) == 0){
            lpdX[*it] = *it;
        }
    }
}

int main(){
    ull tmp;
    ull xmax;
    while(cin >> tmp){
        a.insert(tmp);
        if(tmp > xmax){ xmax = tmp; }
    }
    calcLpd(xmax);

    for(set<ull>::iterator it = a.begin(); it != a.end(); ++it){
        cout << lpdX[*it] << '\n';
    }
    return 0;
}
