#include<bits/stdc++.h>

using namespace std;

struct edge1
{
    int v; int t;
    void setval(int _v, int _t)
    {
        v=_v;
        t=_t;
    }
};

struct edge2
{
    int u; int v; int t;
};

const int maxn=81;
int n, m;
vector<edge1>v[maxn];
int edge_lookup[maxn][maxn];
bool s[maxn];
void read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>s[i];
    }
    int x, y, t;
    edge1 e1;
    for(int i=0;i<m;i++)
    {
        cin>>x>>y>>t;
        e1.setval(y, t);
        v[x].push_back(e1);
        edge_lookup[x][y]=i+1;
    }
}
int used[maxn], p[maxn];
void init()
{
    for(int i=1;i<=n;i++)
    {
        used[i]=INT_MAX;

    }
}

void dfs(int beg, int par, int len, int T)
{
    if(len>2*m)return;
    p[beg]=par;
    used[beg]=T;
    int sz=v[beg].size();
    for(int i=0;i<sz;i++)
    {
        edge1 nb=v[beg][i];
        if(T+nb.t<used[nb.v])
        {
            dfs(nb.v, beg, len+1, T+nb.t);
        }
    }
}

void solve()
{
    read();
    init();
    dfs(1, 0, 0, 0);
    cout<<used[n]<<" ";
    vector<int>route;
    int v=n;
    while(v!=0)
    {
        route.push_back(v);
        v=p[v];
    }
    int sz=route.size();
    cout<<sz-1<<endl;
    while(--sz)
    {
        cout<<edge_lookup[route[sz]][route[sz-1]]<<" "<<1<<endl;
    }
}

int main()
{
    solve();
	return 0;
}
