#include<bits/stdc++.h>

using namespace std;

const int maxn=200000;

vector<int>pos[maxn];

int n, q;
long long pref[maxn];
long long suff[maxn];

void mergev(vector<int>&a, vector<int>&b, vector<int>&res)
{
    int i=0, j=0;
    int sza=a.size(), szb=b.size();
    while(i<sza&&j<szb)
    {
        res.push_back((a[i]<b[j])?a[i++]:b[j++]);
    }
    while(i<sza)
    {
        res.push_back(a[i++]);
    }
    while(j<szb)
    {
        res.push_back(b[j++]);
    }
}

void calcpref(vector<int>&v, int& _sz)
{
    int sz=_sz;
    pref[0]=0;
    for(int i=1;i<sz;i++)
    {
        pref[i]=pref[i-1]+(long long)v[i-1];
    }
}

void calcsuff(vector<int>&v, int& _sz)
{
    int sz=_sz;
    suff[0]=pref[sz-1]+(long long)v[sz-1]-(long long)v[0];
    for(int i=1;i<sz;i++)
    {
        suff[i]=suff[i-1]-(long long)v[i];
    }
}

void solve(int x, int y)
{
    vector<int>ps;
    mergev(pos[x], pos[y], ps);
    int sz=ps.size();
    calcpref(ps, sz);
    calcsuff(ps, sz);
    long long sumi=0, minn=LONG_MAX;
    for(int i=sz/2;i<=sz/2+1&&i<sz;i++)
    {
        long long k=sz-i-1;
        sumi=suff[i]-(long long)k*ps[i]-((k+1)*k)/2
            -pref[i]+(long long)i*ps[i]-(long long)(i*(i+1))/2;
      //  cout<<sumi<<endl;
        if(sumi<minn)
        {
            minn=sumi;
        }
    }
   // cout<<"ANS: ";
    cout<<minn<<endl;
}

void read()
{
    cin>>n>>q;
    int a;
    for(int i=1;i<=n;i++)
    {
        cin>>a;
        pos[a].push_back(i);
    }
    int x, y;
    while(q--)
    {
        cin>>x>>y;
        solve(x, y);
    }
}

int main()
{
    read();
	return 0;
}
