#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 82, maxm = 1000;
long long n, m, s[maxn], dp[maxn][maxn], len[maxn][maxn];

struct edge{
    int x, y, t;
};

vector<edge> v;

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++)
        cin >> s[i];
    for(int i = 1;i <= m;i++){
        int x, y, t;
        cin >> x >> y >> t;
        v.push_back({x, y, t});
    }
}

void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= n;j++){
            dp[i][j] = 1e17;
        }
    }
    dp[1][0] = 0;
    if(s[1] == 1){
        for(int i = 1;i <= n;i++)
            dp[1][i] = 0;
    }
    for(int cycle = 1;cycle <= 2 * m;cycle++){
        for(edge e : v){
            for(int v = 0;v <= n;v++){
                if(dp[e.x][v] == 1e17)
                    continue;
                int j = v + s[e.y];
                if(j > n)
                    j = n;
                if(dp[e.y][j] > dp[e.x][v] + e.t){
                    dp[e.y][j] = min(dp[e.y][j], dp[e.x][v] + e.t);
                    len[e.y][j] = len[e.x][v] + 1;
                }
                if(v > 0){
                    if(dp[e.y][j - 1] > dp[e.x][v]){
                        dp[e.y][j - 1] = dp[e.x][v];
                        len[e.y][j - 1] = len[e.x][v] + 1;
                    }

                }
            }
        }
    }
    long long t = 1e17, l = 0;
    for(int i = 0;i <= n;i++){
        if(t > dp[n][i])
            t = dp[n][i], l = len[n][i];
    }
    cout << t << " " << l << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
