#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 82, maxm = 1002;
long long m, s[maxn], dp[maxn][maxm];
int n, bt[maxn][maxm], used[maxn][maxm], befx[maxn][maxm], befv[maxn][maxm];

struct edge{
    int x, y, t;
};

vector<edge> v;

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++)
        cin >> s[i];
    for(int i = 1;i <= m;i++){
        int x, y, t;
        cin >> x >> y >> t;
        v.push_back({x, y, t});
    }
}
int cnt = 0;

void backtrack(int ver, int vin){
    if(ver == 1)
        return;
    backtrack(befx[ver][vin], befv[ver][vin]);
    cout << bt[ver][vin] << " " << 1 - used[ver][vin] << endl;
}
void solve(){
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= 2 * m;j++){
            dp[i][j] = 1e17;
        }
    }
    dp[1][0] = 0;
    for(int cycle = 1;;cycle++){
        bool f = true;
        for(int i = 0;i < v.size();i++){
            edge e = v[i];
            for(int p = 1;p <= 2 * m;p++){
                if(dp[e.x][p - 1] == 1e17)
                    continue;
                if(dp[e.y][p] > dp[e.x][p - 1] + e.t){
                    dp[e.y][p] = dp[e.x][p - 1] + e.t;
                    befx[e.y][p] = e.x;
                    befv[e.y][p] = p - 1;
                    bt[e.y][p] = i + 1;
                    f = false;
                }
            }
        }
        if(f)
            break;
    }
    long long idx = 1;
    for(int i = 0;i <= 2 * m;i++){
        if(dp[n][idx] > dp[n][i])
            idx = i;
    }
    cout << dp[n][idx] << " " << idx << endl;
    backtrack(n, idx);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
