#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 10;
long long n, q, a[maxn], b[maxn], cnt[maxn], l[maxn];
vector<int> v[maxn];

void read(){
    cin >> n >> q;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        cnt[a[i]]++;
        b[a[i]] += i;
        v[a[i]].push_back(i);
    }
}

int x, y;
bool check(int pos, int t){
    int cnt = 0;
    int l = 0, r = v[x].size() - 1, ans = -1;
    while(l <= r){
        int mid = (l + r) / 2;
        if(v[x][mid] <= pos)
            l = mid + 1, ans = mid;
        else
            r = mid - 1;
    }
    cnt += (ans + 1);
    l = 0, r = v[y].size() - 1, ans = -1;
    while(l <= r){
        int mid = (l + r) / 2;
        if(v[y][mid] <= pos)
            l = mid + 1, ans = mid;
        else
            r = mid - 1;
    }
    cnt += (ans + 1);
    return cnt >= t;
}

void solve(){
    while(q--){
        cin >> x >> y;
        int l = 1, r = n, t = (cnt[x] + cnt[y]) / 2 + (cnt[x] + cnt[y]) % 2;
        while(l <= r){
            int mid = (l + r) / 2;
            if(check(mid, t))
                r = mid - 1;
            else
                l = mid + 1;
        }
        int pos = l;
        int curr = pos;
        long long sum = 0;
        for(int i = pos;i >= 1;i--){
            if(a[i] == x || a[i] == y){
                sum += abs(i - curr);
                curr--;
            }
        }
        curr = pos + 1;
        for(int i = pos + 1;i <= n;i++){
            if(a[i] == x || a[i] == y){
                sum += abs(i - curr);
                curr++;
            }
        }
        cout << sum << endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
