#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 1000000;
bool isPrime[maxN];

ll lpd(ll a)
{
    for (ll i = 2; i * i <= a; i++)
    {
        if (!isPrime[i]) continue;
        if (a % i == 0) return i;
    }

    return a;
}

int main()
{
    for (int i = 0; i < maxN; i++)
    {
        isPrime[i] = true;
    }
    for (int step = 2; step < maxN; step++)
    {
        if (!isPrime[step]) continue;
        for (int i = step * 2; i < maxN; i += step)
        {
            isPrime[i] = false;
        }
    }

    ll temp;
    while (cin >> temp)
    {
        cout << lpd(temp) << endl;
    }
}