#include <iostream>

using namespace std;

typedef long long ll;

const int maxN = 3000100;
const int maxDiff = 5000100;
ll lpd[maxDiff];
ll inputs[maxN];
int t;
ll minX = 10000000000000000;
ll maxX = -1;

ll firstOver(ll num, ll mod)
{
    if (num % mod == 0) return num;
    return num + mod - (num % mod);
}

int main()
{
    for (int i = 0; i < maxDiff; i++)
    {
        lpd[i] = -1;
    }

    ll temp;
    while (cin >> temp)
    {
        inputs[t] = temp;
        t++;
        if (temp < minX) minX = temp;
        if (temp > maxX) maxX = temp;
    }

    for (int step = 2; step < maxN; step++)
    {
//        if (step % 1000000 == 0) cout << step / 1000000 << endl;
        for (ll num = firstOver(minX, step); num <= maxX; num += step)
        {
            if (lpd[num - minX] != -1) continue;
            lpd[num - minX] = step;
        }
    }

    for (int i = 0; i < maxDiff; i++)
    {
        if (lpd[i] == -1)
        {
            lpd[i] = i + minX;
        }
    }

    for (int i = 0; i < t; i++)
    {
        cout << lpd[inputs[i] - minX] << endl;
    }
    return 0;
}
