#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int64_t MAXN = 1e7;

vector <int64_t > primes;
bool isPrime[MAXN+100];
int64_t orderedAns[MAXN];
void Euclid(int64_t  n)
{
    for (int64_t  i = 2; i <= n; i++)
        isPrime[i] = true;

    for (int64_t  i = 2; i <= n; i++)
    {
        if (isPrime[i] == true)
            primes.push_back(i);

        for (int64_t  d = 2; i*d <= n; d++)
        {
            isPrime[i*d] = false;
            if (i%d == 0)
                break;
        }
    }
}

int64_t FindSmallestPrime(int64_t p)
{
    for (int64_t i = 2; i*i <= p; i++)
        if (p%i == 0)
            return i;

    return p;
}
vector <pair<int64_t, int64_t>> arr;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int64_t minA = LLONG_MAX, maxA = 0, a, k = 0;
    while (cin >> a)
    {
        arr.push_back({a, k++});
        maxA = max(maxA, a);
        minA = min(minA, a);
    }

    int64_t  t = arr.size();

    if (maxA < 1e12)
    {
        int64_t  sqrtA = sqrt(maxA) + 1;

        Euclid(sqrtA);

        for (pair <int64_t, int64_t> i:arr)
        {
            bool flag = false;
            for (int64_t  p:primes)
            {
                if (i.first%p == 0)
                {
                    cout << p << endl;
                    flag = true;
                    break;
                }
            }

            if (flag == false)
                cout << i.first << endl;
        }
    }

    else
    {
        Euclid(5000000);
        sort(arr.begin(), arr.end());

        map <int64_t, int64_t> ans;

        for (int64_t i = minA; i <= maxA; i++)
        {

            if (ans.find(i) != ans.end())
                continue;

            int64_t pmin;
            for (int64_t p:primes)
            {
                if (i%p == 0)
                {
                    pmin = p;
                    break;
                }
            }


            for (int64_t j = i; j >= minA; j-= pmin)
            {
                if (ans.find(j) != ans.end())
                    continue;
                ans[j] = pmin;
            }

            for (int64_t j = i; j <= maxA; j+= pmin)
            {
                if (ans.find(j) != ans.end())
                    continue;
                ans[j] = pmin;
            }

        }

        for (pair <int64_t, int64_t> i:arr)
        {
            if (ans.find(i.first) == ans.end())
                ans[i.first] = FindSmallestPrime(i.first);

            orderedAns[i.second] = ans[i.first];
        }

        for (int i = 0; i < arr.size(); i++)
            cout << orderedAns[i] << endl;
    }


    return 0;
}
