#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e6;
vector <int> pos[MAXN+10];
int a[MAXN+10];

struct Group
{
    int l, r, length;
    Group(){}
    Group(int l, int r, int length)
        :l(l), r(r), length(length){}
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        pos[a[i]].push_back(i);
    }

    for (int i = 1; i <= q; i++)
    {
        int x, y;
        cin >> x >> y;

        vector <int> allPos;
        int sizeX = pos[x].size();
        int sizeY = pos[y].size();
        allPos.reserve(sizeX + sizeY);

        int xInd = 0, yInd = 0;
        while (xInd < sizeX && yInd < sizeY)
        {
            if (pos[x][xInd] < pos[y][yInd])
            {
                allPos.push_back(pos[x][xInd]);
                xInd++;
            }
            else
            {
                allPos.push_back(pos[y][yInd]);
                yInd++;
            }
        }

        while (xInd < sizeX)
            allPos.push_back(pos[x][xInd++]);

        while (yInd < sizeY)
            allPos.push_back(pos[y][yInd++]);

        vector <Group> groups;

        int currL = allPos[0];
        for (int j = 1; j < allPos.size(); j++)
        {
            if (allPos[j] != allPos[j-1] + 1)
            {
                groups.emplace_back(currL, allPos[j-1], allPos[j-1]-currL + 1);
                currL = allPos[j];
            }
        }
        groups.emplace_back(currL, allPos[allPos.size()-1], allPos[allPos.size()-1]-currL + 1);

        vector <int64_t> br(groups.size()+1);
        vector <int64_t> prefix(groups.size());
        vector <int64_t> suffix(groups.size());

        prefix[0] = suffix[groups.size()-1] = 0;
        br[0] = groups[0].length;

        for (int j = 1; j < groups.size(); j++)
        {
            br[j] = br[j-1] + groups[j].length;
        }

        for (int j = 1; j < groups.size(); j++)
        {
            prefix[j] = prefix[j-1] + br[j-1]*(groups[j].l - groups[j-1].r - 1);
        }

        for (int j = groups.size()-2; j >= 0; j--)
        {
            suffix[j] = suffix[j+1] + (br[groups.size()-1]-br[j])*(groups[j+1].l - groups[j].r - 1);
        }

        int64_t ans = LLONG_MAX;
        for (int j = 0; j < groups.size(); j++)
        {
            ans = min(ans, prefix[j] + suffix[j]);
        }

        cout << ans << endl;

       /* for (int j = 0; j < groups.size(); j++)
        {
            cout << prefix[j] << " ";
        }
        cout << endl;
        for (int j = 0; j < groups.size(); j++)
        {
            cout << suffix[j] << " ";
        }
        cout << endl;

        cout << "*******************" << endl;*/


    }

    return 0;
}
