#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 88;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m,s[MAXN];
int dist[MAXN][MAXN], path[MAXN][MAXN];
int inf = 1e17;
void precompute()
{
    for (int i = 1; i <= n; ++ i)
    {
        for(int j = i + 1; j <= n; ++ j)
        {
            dist[i][j] = inf;
            dist[j][i] = inf;
            path[i][j] = 0;
            path[j][i] = 0;
        }
    }
}
int xx, yy, cost;
vector < int > way[MAXN][MAXN];
int main()
{
    //speed();
    cin >> n >> m;
    precompute();
    for (int i = 1; i <= n; ++ i)
        cin >> s[i];
    for (int i = 1; i <= m; ++ i)
    {
       // cout<< i << ": " << endl;
        cin >> xx >> yy >> cost;
        if(dist[xx][yy] > cost)
        {
            path[xx][yy] = 1;
            dist[xx][yy] = cost;
            way[xx][yy].clear();
            way[xx][yy].push_back(i);
        }
    }
    int cycle = 2*m;
    while(cycle --)
    {
        for (int k = 1; k <= n; ++ k)
    {
        for (int i = 1; i <= n; ++ i)
        {
            for (int j = 1; j <= n; ++ j)
            {
               // if(i == j )continue;
                if(dist[i][k]!=inf && dist[k][j] != inf && dist[i][j] > dist[i][k] + dist[k][j])
                {
                    int newpath= path[i][k] + path[k][j];
                    if(newpath > 2*m)break;
                    else
                    {dist[i][j] = dist[i][k] + dist[k][j];
                    path[i][j] = path[i][k] + path[k][j];
                    way[i][j].clear();
                    way[i][j] = way[i][k];
                    for (int index = 0; index < way[k][j].size(); ++ index)
                        way[i][j].push_back(way[k][j][index]);
                    path[i][j] = way[i][j].size();
                    }
                }
            }
        }
    }

    }

    cout << dist[1][n] << " " << path[1][n] << endl;
    for (int i = 0; i < way[1][n].size(); ++ i)
        cout << way[1][n][i] << " " << 1 << endl;
    return 0;
}
