#include <bits/stdc++.h>
#define MAXN 81
using namespace std;
int s[MAXN];
vector<pair<int,int>> edges[MAXN];
int previous[MAXN];int dist[MAXN];
int brV[MAXN];int m; int n;
priority_queue<pair<int,int>> pq;
void dijkstra()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    previous[1] = -1;
    brV[1] = 1;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int curr = pq.top().second;
        int currDist = -pq.top().first;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        for (auto next : edges[curr])
        {
            int v = next.first;
            int w = next.second;
            if ( currDist + w < dist[v] && brV[curr] + 1 <= 2*m )
            {
                dist[v] = currDist + w;
                previous[v] = curr;
                brV[v] = brV[curr] + 1;
                pq.push({-dist[v], v});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i=1; i<=n; i++)
        cin >> s[i];
    for (int j=0; j<m; j++)
    {
        int a, b, t; cin >> a >> b >> t;
        edges[a].push_back({b, t});
    }
    dijkstra();
    int T, L;
    T = dist[n];
    L = brV[n];
    cout << T << " " << L << endl;
    stack<int> path;
    while ( n != -1 )
    {
        path.push(n);
        n = previous[n];
    }

    while ( !path.empty() )
    {
        cout << path.top() << " " << 0 << endl;;
        path.pop();
    }
    cout << endl;
}
/*
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 5
1 2 4 5 6
*/
