#include <bits/stdc++.h>
#define MAXN 81
using namespace std;
int s[MAXN];
vector<pair<int,int>> edges[MAXN];
int previous[MAXN];
int dist[MAXN];
int brV[MAXN];
int m;
int n;
struct My
{
    int distV;
    int V;
    int brVin;
    My(){}
    My(int d, int v, int br)
    {
        distV = d;
        V = v;
        brVin = br;
    }
    bool operator<(My& other)
    {
        if ( this->distV == other.distV ) return this->brVin > other.brVin;
        return this->distV < other.distV ;
    }
};
priority_queue<My> pq;
void dijkstra()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    previous[1] = -1;
    brV[1] = 1;
    pq.push({0, 1, (s[1])? 1 : 0});
    while (!pq.empty())
    {
        int curr = pq.top().V;
        int currDist = pq.top().distV;
        int vin = pq.top().brVin;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        for (auto next : edges[curr])
        {
            int v = next.first;
            int w = next.second;
            int vinetki = vin;
            if ( s[v] && vin+1 <= n ) vinetki++;
           
            if ( currDist + w < dist[v] && brV[curr] + 1 <= 2*m )
            {
                
                dist[v] = currDist + w;
                previous[v] = curr;
                brV[v] = brV[curr] + 1;
                pq.push({dist[v], v, vinetki});
            }
            if ( vin && currDist < dist[v] && brV[curr] + 1 <= 2*m )
            {
                dist[v] = currDist;
                previous[v] = curr;
                brV[v] = brV[curr] + 1;
                pq.push({dist[v], v, vinetki-1});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i=1; i<=n; i++)
        cin >> s[i];
    for (int j=0; j<m; j++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        edges[a].push_back({b, t});
    }
    dijkstra();
    int T, L;
    T = dist[n];
    L = brV[n];
    cout << T << " " << L << endl;
    stack<int> path;
    while ( n != -1 )
    {
        path.push(n);
        n = previous[n];
    }

    while ( !path.empty() )
    {
        cout << path.top() << " " << 0 << endl;;
        path.pop();
    }
    cout << endl;
}
/*
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 5
1 2 4 5 6
*/
