#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 81
using namespace std;

vector<pair<int,int>> edges[MAXN];
int previous[MAXN];
int dist[MAXN];
int brV[MAXN];
int m;
int n;
/*priority_queue<pair<int,int>> pq;
void dijkstra()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    previous[1] = -1;
    brV[1] = 1;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int curr = pq.top().second;
        int currDist = -pq.top().first;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        for (auto next : edges[curr])
        {
            int v = next.first;
            int w = next.second;
            if ( currDist + w < dist[v] && brV[curr] + 1 <= 2*m )
            {
                dist[v] = currDist + w;
                previous[v] = curr;
                brV[v] = brV[curr] + 1;
                pq.push({-dist[v], v});
            }
        }
    }
}*/
void bellmanford()
{
    fill_n(dist, n+1, INT_MAX);
    dist[1] = 0;
    brV[1] = 1;
    previous[1] = -1;
    for (int k=1; k<2*m; k++)//!!
    {
        for (int i=1; i<=n; i++)
            for (auto edge : edges[i])
        {
            if ( dist[i] != INT_MAX && dist[i] + edge.second < dist[edge.first] && brV[i] + 1 <= 2*m )
            {
                dist[edge.first] = dist[i] + edge.second;
                previous[edge.first] = i;
                brV[edge.first] = brV[i] + 1;
            }
        }
    }
}
stack<int> path;
int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> m;
    int s;
    for (int i=1; i<=n; i++)
        cin >> s;
    bool neg = true;
    for (int j=0; j<m; j++)
    {
        int a, b, t;
        if ( t < 0 ) neg = true;
        cin >> a >> b >> t;
        edges[a].push_back({b, t});
    }
    int T, L;
    if ( !neg )
    {
       // dijkstra();

        T = dist[n];
        L = brV[n];
    }
    else
    {
        bellmanford();
        T = dist[n];
        L = brV[n];
    }

    cout << T << " " << L << endl;

    while ( n != -1 && n != 0 )
    {
        path.push(n);
        if ( n == 1 ) break;
        n = previous[n];
    }

    while ( !path.empty() )
    {
        cout << path.top() << " " << 0 << endl;;
        path.pop();
    }

}
/*
5 5
0 0 0 0 0
1 2 -2
2 3 4
2 4 8
4 3 -10
3 5 -5
---------------
-9 5
1 0
2 0
4 0
3 0
5 0
========================
6 7
0 0 0 0 0 0
1 2 2
2 3 4
2 4 5
4 5 1
3 5 3
5 6 1
1 6 10
-----------------
9 5
1 0
2 0
4 0
5 0
6 0
*/
