#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int vi, int di, int ni)
    {
        ver = vi;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 85;

int n,m,s[maxn];
vector<edge>g[maxn];
unsigned int d[maxn],inf = -1;
int par[maxn],nom[maxn];
vector<int>ans;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++) cin >> s[i];
    int a,b,t;
    for(int i=1;i<=m;i++)
    {
        cin >> a >> b >> t;
        g[a].push_back({b,t,i});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    d[beg] = 0;
    priority_queue<edge>q;
    q.push({beg,0,0});
    while(!q.empty())
    {
        edge e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            for(edge nb:g[e.ver])
            {
                if(nb.dist+e.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    par[nb.ver] = e.ver;
                    nom[nb.ver] = e.num;
                    q.push(nb);
                }
            }
        }
    }
}

void rec(int x)
{
    if(nom[x]==0) return;
    rec(par[x]);
    ans.push_back(nom[x]);
}

void solve()
{
    dijkstra(1);
    cout << d[n] << " ";
    rec(n);
    cout << ans.size() << endl;
    for(int i=0;i<ans.size();i++) cout << ans[i] << " " << 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
