#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int ve, int di, int ni)
    {
        ver = ve;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 85;

int n,m,s[maxn];
vector<edge>g[maxn];
int par[maxn],nom[maxn];
unsigned int inf = -1;
long long res = inf;
vector<int>ans;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++) cin >> s[i];
    int a,b,t;
    for(int i=1;i<=m;i++)
    {
        cin >> a >> b >> t;
        g[a].push_back({b,t,i});
    }
}

void dfs(int beg, vector<int>v, long long path)
{
    if(beg==n&&path<res)
    {
        res = path;
        ans = v;
    }
    if(v.size()>=2*n) return;
    for(edge nb:g[beg])
    {
        v.push_back(nb.num);
        dfs(nb.ver,v,path+nb.dist);
        v.pop_back();
    }
}

void solve()
{
    vector<int>pom;
    dfs(1,pom,0);
    cout << res << " " << ans.size() << endl;
    for(int i=0;i<ans.size();i++) cout << ans[i] << " " << 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
