#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int ve, int di, int ni)
    {
        ver = ve;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 85;

int n,m,s[maxn];
vector<edge>g[maxn];
int par[maxn],nom[maxn];
long long d[maxn][maxn][2];
unsigned int inf = -1;
long long res = inf;
vector<int>ans;
vector<pair<int,edge> > sp;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++) cin >> s[i];
    int a,b,t;
    pair<int,edge>p;
    for(int i=1;i<=m;i++)
    {
        cin >> a >> b >> t;
        g[a].push_back({b,t,i});
        p.first = b;
        p.second = {a,t,i};
        sp.push_back(p);
    }
    sort(sp.begin(),sp.end());
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=n;j++)
        {
            d[i][j][0] = inf;
        }
    }
    d[1][s[1]][0] = 0;
    res = min(res,d[n][s[n]][0]);
    int tek,old;
    tek = old = 0;
    for(int z=1;z<=2*m;z++)
    {
        tek = z%2;
        for(int j=0;j<=n;j++)
        {
            for(int i=0;i<sp.size();i++)
            {
                int b = sp[i].first;
                d[b][j+s[b]][tek] = inf;
                int p = i;
                while(p<sp.size()&&sp[p].first==sp[i].first)
                {
                    edge nb = sp[p].second;
                    if(j+s[b]<=n) d[b][j+s[b]][tek] = min(d[b][j+s[b]][tek],d[nb.ver][j][old] + nb.dist);
                    if(0<=j+s[b]-1&&j+s[b]-1<=n) d[b][j+s[b]][tek] = min(d[b][j+s[b]-1][tek],d[nb.ver][j][old]);
                    p++;
                }
                i = p-1;
            }
        }
        for(int j=0;j<=n;j++) res = min(res,d[n][j][tek]);
        old = tek;
    }
    cout << res << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
