#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int ve, int di, int ni)
    {
        ver = ve;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 81;

int n,m,s[maxn];
vector<edge>g[maxn];
int par[maxn],nom[maxn];
long long d[maxn][maxn][1001];
long long inf = 3e9;
long long res = inf;
vector<int>ans;
vector<pair<int,edge> > sp;

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++) cin >> s[i];
    int a,b,t;
    pair<int,edge>p;
    for(int i=1;i<=m;i++)
    {
        cin >> a >> b >> t;
        g[a].push_back({b,t,i});
        p.first = b;
        p.second = {a,t,i};
        sp.push_back(p);
    }
    sort(sp.begin(),sp.end());
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<=n;j++)
        {
            for(int z=0;z<=2*m;z++) d[i][j][z] = inf;
        }
    }
    d[1][s[1]][0] = 0;
    res = min(res,d[n][s[n]][0]);
    int tek,old;
    tek = old = 0;
    for(int z=1;z<=2*m;z++)
    {
        for(int j=0;j<=n;j++)
        {
            for(int i=0;i<sp.size();i++)
            {
                int b = sp[i].first;
                edge nb = sp[i].second;
                if(j+s[b]<=n) d[b][j+s[b]][z] = min(d[b][j+s[b]][z],d[nb.ver][j][z-1] + nb.dist);
                if(0<=j-1&&j+s[b]<=n) d[b][j+s[b]-1][z] = min(d[b][j+s[b]-1][z],d[nb.ver][j][z-1]);
            }
        }
        for(int j=0;j<=n;j++) res = min(res,d[n][j][z]);
    }
    cout << res << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
