#include<bits/stdc++.h>
using namespace std;
const int MAXN = 100;
const int ADD = 100007;
const long long INF = 10000000000;
int n, m;
long long T, L;
int s[MAXN];
vector< pair< pair<int,int> ,int> > g[MAXN];
int wrote[MAXN];
long long dist[MAXN];
void Dijkstra(){
    for(int i = 1 ; i <= n ; i++) dist[i] = INF;
    priority_queue<pair<int,int>> pq;
    int v;
    long long d;
    int u,d_u;
    pq.push({0,1});
    dist[1] = 0;
    while(!pq.empty()){
        v = pq.top().second;
        d = - pq.top().first;
        pq.pop();
        if(dist[v] != d)continue;
        for(int i = 0 ; i < g[v].size() ; i++){
            u = g[v][i].first.first;
            d_u = g[v][i].first.second;
            if(dist[u] > d_u + d){
                dist[u] = d_u + d;
                pq.push({-dist[u],u});
                wrote[u] = v;
            }
        }
    }
    T = dist[n];
}
int fnd(int u, int v){
    for(int i = 0 ; i < g[u].size() ; i++){
        if(g[u][i].first.first == v) return g[u][i].second;
    }
    while(true) cout<<1;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin>>n>>m;
    for(int i = 0 ; i < n ; i++) cin>>s[i];
    int u,v;
    long long t;
    for(int i = 1 ; i <= m ; i++){
        cin>>u>>v>>t;
        g[u].push_back({{v,t},i});
    }
    Dijkstra();

    //v --. u
    v = n;
    L = 0;
    vector<int> ans;
    while(v!=1){
        u = v;
        v = wrote[u];
        //cout<<u<<" "<<v<<endl;
        L++;
        ans.push_back(fnd(v,u));
    }
    cout<<T<<" "<<L<<"\n";
    for(int i = ans.size()-1 ; i >= 0 ; i--){
        cout<<ans[i]<<" 1"<<"\n";
    }
    return 0;
}
/*
5 6
0 0 0 0  0
1 2 1
2 3 1
3 4 0
4 5 0
2 5 1
1 5 3

4 5
0 0 0 0
1 2 1
2 3 1
1 3 3
1 4 5
3 4 2
*/
