#include <iostream>
#include <chrono>
#include <vector>
#include <stack>
#include <assert.h>
#include <map>

#define maxn 1000005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

long long n;

long long find_factor(long long n)
{

    if(n % 2 == 0) return 2;

    for(int i = 3; (long long)(i * i) <= n; i += 2)
    {
        if(n % i == 0) return i;
    }

    return n;

}

map <int , int> used;

void solve()
{
    ///_sieve(1e6 + 1);

    ///cin >> t;
    while( cin >> n )
    {

        ///if(n > 1e9) assert(false);

        //cin >> n;
        ///cout << sieve[n] << endl;

        if(used[n] != 0)
        {
            cout << used[n] << endl;
            continue;
        }

        int ans = find_factor(n);

        used[n] = ans;
        cout << ans << endl;

        //if(timePassed() > (double)(1.1)) assert(false);

    }

}


int main()
{

#ifdef ONLINE_JUDGE
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();

    solve();


    return 0;
}
